/*
 * =====================================================================================
 *
 *       Filename:  test_del.cpp
 *
 *    Description:  Testing Double Deletes
 *
 *        Version:  1.0
 *        Created:  04/02/2011 05:12:24 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  YOUR NAME Ruben Safir, 
 *        Company:  NYLXS
 *
 * =====================================================================================
 */



#ifndef  LINKLIST
#define LINKLIST
#include	"linklist.h"
#include       "stats.h"
#endif     /* -----  not LINKLIST  ----- */

#include	<iostream>
#include	<fstream>
#include 	<climits>
#include	<stdlib.h>
#include        <iomanip>

chainlist::List<int>* creating_int_list();
void find_all_examples(chainlist::List<int>*&, int);



template <typename T>
void test_me(stats::Distribution<T> hello){
   std::cout  << "I recied an int and converted it to an object " << hello << std::endl;
}



int main ( int argc, char *argv[] ){
   int a = 7;
   test_me<int>(a);

   return EXIT_SUCCESS;
}				/* ----------  end of function main  ---------- */


chainlist::List<int> * creating_int_list(){
   // chainlist::List<int>  set = new chainlist::List<int>;
   chainlist::List<int> * set = new chainlist::List<int>;
   int ran;
   for(int i = 0; i < 100; ++i){
      ran=rand();
      set->insert(ran % 100);
   }
   set->display();
   return set;
}

void find_all_examples ( chainlist::List<int>* & glob, int search_value )
{
   std::cout << "Searching for " <<  search_value << " in list \n" ;
   glob->display();
   glob->find_value(search_value);
   chainlist::Node<int> * found = glob->cursor();
   if(found){
      std::cout << "Found first value ==> '" << *found->value() << "' at node =='" << glob->cursor() << std::endl;
      found = glob->find_next_value(search_value, found); 
      while( found ){ 
	 std::cout << "Found next value ==> '" << *(found->value()) << "' at node =='" << glob->cursor() << std::endl;
	 found = glob->find_next_value(search_value, found);
      }
   }


   return ;
}		

